Lucene++ - a full-featured, c++ search engine
API Documentation

Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::Set< TYPE, LESS > Class Template Reference

Utility template class to handle set based collections that can be safely copied and shared. More...

`#include <Set.h>`

Inheritance diagram for Lucene::Set< TYPE, LESS >:

## Public Types

typedef Set< TYPE, LESS > | this_type
typedef std::set< TYPE, LESS > | set_type
typedef set_type::iterator | iterator
typedef set_type::const_iterator | const_iterator
typedef TYPE | value_type

## Public Member Functions

virtual | ~Set ()
void | reset ()
int32_t | size () const
bool | empty () const
void | clear ()
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
bool | add (const TYPE &type)
template<class ITER >
void | addAll (ITER first, ITER last)
bool | remove (const TYPE &type)
iterator | find (const TYPE &type)
bool | contains (const TYPE &type) const
bool | equals (const this_type &other) const
template<class PRED >
bool | equals (const this_type &other, PRED comp) const
void | swap (this_type &other)
| operator bool () const
bool | operator! () const
bool | operator== (const this_type &other)
bool | operator!= (const this_type &other)
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static this_type | newInstance ()
template<class ITER >
static this_type | newInstance (ITER first, ITER last)

## Protected Attributes

boost::shared_ptr< set_type > | setContainer
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

### template<class TYPE, class LESS = std::less<TYPE>>
class Lucene::Set< TYPE, LESS >

Utility template class to handle set based collections that can be safely copied and shared.

## Member Typedef Documentation

## ◆ const_iterator

template<class TYPE , class LESS = std::less<TYPE>>

typedef set_type::const_iterator Lucene::Set< TYPE, LESS >::const_iterator

## ◆ iterator

template<class TYPE , class LESS = std::less<TYPE>>

typedef set_type::iterator Lucene::Set< TYPE, LESS >::iterator

## ◆ set_type

template<class TYPE , class LESS = std::less<TYPE>>

typedef std::set<TYPE, LESS> Lucene::Set< TYPE, LESS >::set_type

## ◆ this_type

template<class TYPE , class LESS = std::less<TYPE>>

typedef Set<TYPE, LESS> Lucene::Set< TYPE, LESS >::this_type

## ◆ value_type

template<class TYPE , class LESS = std::less<TYPE>>

typedef TYPE Lucene::Set< TYPE, LESS >::value_type

## Constructor & Destructor Documentation

## ◆ ~Set()

template<class TYPE , class LESS = std::less<TYPE>>

virtual Lucene::Set< TYPE, LESS >::~Set | ( |  | ) |

inline virtual

## Member Function Documentation

## ◆ add()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::add | ( | const TYPE & | type | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ addAll()

template<class TYPE , class LESS = std::less<TYPE>>
template<class ITER >

void Lucene::Set< TYPE, LESS >::addAll | ( | ITER | first,
|  | ITER | last
| ) |  |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ begin() [1/2]

template<class TYPE , class LESS = std::less<TYPE>>

iterator Lucene::Set< TYPE, LESS >::begin | ( |  | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ begin() [2/2]

template<class TYPE , class LESS = std::less<TYPE>>

const_iterator Lucene::Set< TYPE, LESS >::begin | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ clear()

template<class TYPE , class LESS = std::less<TYPE>>

void Lucene::Set< TYPE, LESS >::clear | ( |  | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ contains()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::contains | ( | const TYPE & | type | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ empty()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::empty | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ end() [1/2]

template<class TYPE , class LESS = std::less<TYPE>>

iterator Lucene::Set< TYPE, LESS >::end | ( |  | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ end() [2/2]

template<class TYPE , class LESS = std::less<TYPE>>

const_iterator Lucene::Set< TYPE, LESS >::end | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ equals() [1/2]

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::equals | ( | const this_type & | other | ) | const

inline

## ◆ equals() [2/2]

template<class TYPE , class LESS = std::less<TYPE>>
template<class PRED >

bool Lucene::Set< TYPE, LESS >::equals | ( | const this_type & | other,
|  | PRED | comp
| ) |  | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ find()

template<class TYPE , class LESS = std::less<TYPE>>

iterator Lucene::Set< TYPE, LESS >::find | ( | const TYPE & | type | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ newInstance() [1/2]

template<class TYPE , class LESS = std::less<TYPE>>

static this_type Lucene::Set< TYPE, LESS >::newInstance | ( |  | ) |

inline static

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ newInstance() [2/2]

template<class TYPE , class LESS = std::less<TYPE>>
template<class ITER >

static this_type Lucene::Set< TYPE, LESS >::newInstance | ( | ITER | first,
|  | ITER | last
| ) |  |

inline static

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ operator bool()

template<class TYPE , class LESS = std::less<TYPE>>

Lucene::Set< TYPE, LESS >::operator bool | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ operator!()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::operator! | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ operator!=()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::operator!= | ( | const this_type & | other | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ operator==()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::operator== | ( | const this_type & | other | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ remove()

template<class TYPE , class LESS = std::less<TYPE>>

bool Lucene::Set< TYPE, LESS >::remove | ( | const TYPE & | type | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ reset()

template<class TYPE , class LESS = std::less<TYPE>>

void Lucene::Set< TYPE, LESS >::reset | ( |  | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ size()

template<class TYPE , class LESS = std::less<TYPE>>

int32_t Lucene::Set< TYPE, LESS >::size | ( |  | ) | const

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## ◆ swap()

template<class TYPE , class LESS = std::less<TYPE>>

void Lucene::Set< TYPE, LESS >::swap | ( | this_type & | other | ) |

inline

References Lucene::Set< TYPE, LESS >::setContainer.

## Field Documentation

## ◆ setContainer

template<class TYPE , class LESS = std::less<TYPE>>

boost::shared_ptr<set_type> Lucene::Set< TYPE, LESS >::setContainer

protected

Referenced by Lucene::Set< TYPE, LESS >::add(), Lucene::Set< TYPE, LESS >::addAll(), Lucene::Set< TYPE, LESS >::begin(), Lucene::Set< TYPE, LESS >::clear(), Lucene::Set< TYPE, LESS >::contains(), Lucene::Set< TYPE, LESS >::empty(), Lucene::Set< TYPE, LESS >::end(), Lucene::Set< TYPE, LESS >::equals(), Lucene::Set< TYPE, LESS >::find(), Lucene::Set< TYPE, LESS >::newInstance(), Lucene::Set< TYPE, LESS >::operator bool(), Lucene::Set< TYPE, LESS >::operator!(), Lucene::Set< TYPE, LESS >::operator!=(), Lucene::Set< TYPE, LESS >::operator==(), Lucene::Set< TYPE, LESS >::remove(), Lucene::Set< TYPE, LESS >::reset(), Lucene::Set< TYPE, LESS >::size(), and Lucene::Set< TYPE, LESS >::swap().

The documentation for this class was generated from the following file:

- Set.h

clucene.sourceforge.net